## brotli 0.2

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 0.2
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
    person("Google, Inc", role = "cph", comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that compresses data using
    a combination of the LZ77 algorithm and Huffman coding, with efficiency
    comparable to the best currently available general-purpose compression
    methods. Brotli is similar in speed to deflate but offers more dense
    compression.
License: Apache License 2.0
URL: http://www.ietf.org/id/draft-alakuijala-brotli
        https://github.com/google/brotli
BugReports: http://github.com/jeroenooms/brotli/issues
VignetteBuilder: R.rsp
Suggests: R.rsp
NeedsCompilation: yes
Packaged: 2015-10-03 11:04:07 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
Repository: CRAN
Date/Publication: 2015-10-03 19:21:41

## brotli 0.3

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 0.3
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
    person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that uses a combination of the LZ77
    algorithm and Huffman coding. Brotli is similar in speed to deflate (gzip) but
    offers more dense compression.
License: Apache License 2.0
URL: http://www.ietf.org/id/draft-alakuijala-brotli
        https://github.com/google/brotli
BugReports: http://github.com/jeroenooms/brotli/issues
VignetteBuilder: R.rsp
Suggests: R.rsp
NeedsCompilation: yes
Packaged: 2015-10-04 15:07:31 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [aut, cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
Repository: CRAN
Date/Publication: 2015-10-06 09:18:29

## brotli 0.3.0+dfsg

=== enc/Makefile ===
#brotli/enc

include ../shared.mk

OBJS_NODICT = backward_references.o block_splitter.o brotli_bit_stream.o encode.o encode_parallel.o entropy_encode.o histogram.o literal_cost.o metablock.o static_dict.o streams.o utf8_util.o
OBJS = $(OBJS_NODICT) dictionary.o

nodict : $(OBJS_NODICT)

all : $(OBJS)

clean :
	rm -f $(OBJS) $(SO)

=== debian/changelog ===
brotli (0.3.0+dfsg-2) unstable; urgency=medium

  * d/copyright: update to MIT
  * move brotli to the "utils" section (Closes: #814704)

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 15 Feb 2016 09:53:52 +0100

brotli (0.3.0+dfsg-1) unstable; urgency=medium

  * d/gbp.conf: updated filtered files
  * d/patches: drop patches merged upstream
  * Imported Upstream version 0.3.0+dfsg

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 05 Feb 2016 22:10:56 +0100

brotli (0.2.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #808062)

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 16 Dec 2015 10:34:42 +0100

=== debian/control ===
Source: brotli
Section: python
Priority: optional
Maintainer: Tomasz Buchert <tomasz@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               python,
               python-dev,
               python-setuptools,
               python3,
               python3-dev,
               python3-setuptools
Standards-Version: 3.9.6
Homepage: https://github.com/google/brotli
Vcs-Git: git://anonscm.debian.org/collab-maint/brotli.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/brotli.git

Package: python-brotli
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: lossless compression algorithm and format (Python 2 version)
 Brotli is a generic-purpose lossless compression algorithm
 that compresses data using a combination of a modern variant
 of the LZ77 algorithm, Huffman coding and 2nd order context modeling,
 with a compression ratio comparable to the best currently available
 general-purpose compression methods. It is similar in speed with
 deflate but offers more dense compression.
 .
 This package installs a Python 2 module.

Package: python3-brotli
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: lossless compression algorithm and format (Python 3 version)
 Brotli is a generic-purpose lossless compression algorithm
 that compresses data using a combination of a modern variant
 of the LZ77 algorithm, Huffman coding and 2nd order context modeling,
 with a compression ratio comparable to the best currently available
 general-purpose compression methods. It is similar in speed with
 deflate but offers more dense compression.
 .
 This package installs a Python 3 module.

Package: brotli
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: lossless compression algorithm and format (command line utility)
 Brotli is a generic-purpose lossless compression algorithm
 that compresses data using a combination of a modern variant
 of the LZ77 algorithm, Huffman coding and 2nd order context modeling,
 with a compression ratio comparable to the best currently available
 general-purpose compression methods. It is similar in speed with
 deflate but offers more dense compression.
 .
 This package installs a command line utility.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export PYBUILD_NAME = brotli

%:
	dh $@ --buildsystem=pybuild --with=python2 --with=python3

override_dh_auto_build:
	dh_auto_build
	(cd tools; make)

BROTLI_CMD=brotli
override_dh_install:
	cp tools/bro tools/$(BROTLI_CMD)
	dh_install

override_dh_auto_clean:
	rm -f tools/$(BROTLI_CMD)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	dh_auto_test
	debian/smoke_test.sh
endif

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg//,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/brotli-$1\.tar\.gz/ \
  https://github.com/google/brotli/tags .*/v?(\d\S*)\.tar\.gz

## brotli 0.4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: brotli
 Type: Package
 Title: A Compression Format Optimized for the Web
-Version: 0.3
+Version: 0.4
 Authors@R: c(
     person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
     person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
@@ -13,12 +13,12 @@
 URL: http://www.ietf.org/id/draft-alakuijala-brotli
         https://github.com/google/brotli
 BugReports: http://github.com/jeroenooms/brotli/issues
-VignetteBuilder: R.rsp
-Suggests: R.rsp
+VignetteBuilder: knitr, R.rsp
+Suggests: knitr, R.rsp, microbenchmark, ggplot2
 NeedsCompilation: yes
-Packaged: 2015-10-04 15:07:31 UTC; jeroen
+Packaged: 2015-11-25 19:22:57 UTC; jeroen
 Author: Jeroen Ooms [aut, cre],
   Google, Inc [aut, cph] (Brotli C++ library)
 Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
 Repository: CRAN
-Date/Publication: 2015-10-06 09:18:29
+Date/Publication: 2015-11-26 08:33:03

## brotli 0.4.0+dfsg

=== debian/changelog ===
brotli (0.4.0+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 0.4.0+dfsg
  * Bumped Standards-Version to 3.9.8 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 18 Jun 2016 15:22:06 +0200

brotli (0.3.0+dfsg-3) unstable; urgency=medium

  [ Raúl Benencia ]
  * Fixes for CVE-2016-1968 and CVE-2016-1624 (Closes: #817233)

  [ Tomasz Buchert ]
  * Bump Standards-Version to 3.9.7 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 27 Mar 2016 09:00:55 +0200

## brotli 0.5

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 0.5
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
    person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that uses a combination of the LZ77
    algorithm and Huffman coding. Brotli is similar in speed to deflate (gzip) but
    offers more dense compression.
License: MIT + file LICENSE
URL: http://www.ietf.org/id/draft-alakuijala-brotli
        https://github.com/google/brotli
BugReports: http://github.com/jeroenooms/brotli/issues
VignetteBuilder: knitr, R.rsp
Suggests: knitr, R.rsp, microbenchmark, ggplot2
NeedsCompilation: yes
Packaged: 2016-01-23 21:18:04 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [aut, cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
Repository: CRAN
Date/Publication: 2016-01-23 23:28:19

## brotli 0.5.2+dfsg

=== debian/changelog ===
brotli (0.5.2+dfsg-2) unstable; urgency=medium

  * Make object list deterministic (Closes: #845780)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 18 Dec 2016 11:37:54 +0100

brotli (0.5.2+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 0.5.2+dfsg (Closes: #842016)
  * Update debian/rules to use new build system

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 25 Oct 2016 23:08:26 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                python3,
                python3-dev,
                python3-setuptools
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/google/brotli
 Vcs-Git: git://anonscm.debian.org/collab-maint/brotli.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/brotli.git

## brotli 0.6

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 0.6
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
    person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that uses a combination of the
    LZ77 algorithm and Huffman coding. Brotli is similar in speed to deflate (gzip)
    but offers more dense compression.
License: MIT + file LICENSE
URL: http://www.ietf.org/id/draft-alakuijala-brotli
        https://github.com/google/brotli
BugReports: http://github.com/jeroenooms/brotli/issues
VignetteBuilder: knitr, R.rsp
Suggests: knitr, R.rsp, microbenchmark, ggplot2
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-03-01 14:28:53 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [aut, cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
Repository: CRAN
Date/Publication: 2016-03-01 17:07:48

## brotli 0.6.0

=== debian/changelog ===
brotli (0.6.0-1build1) artful; urgency=medium

  * No-change rebuild to build with python3.6.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 13:50:44 +0000

brotli (0.6.0-1) unstable; urgency=medium

  * d/*: debhelper 10 and uscan 4
  * New upstream version 0.6.0

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 23 Apr 2017 19:54:21 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: python
 Priority: optional
 Maintainer: Tomasz Buchert <tomasz@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                dh-python,
                python,
                python-dev,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export PYBUILD_NAME = brotli

%:
	dh $@ --buildsystem=pybuild --with=python2,python3

override_dh_auto_build:
	dh_auto_build
	make bro

BROTLI_CMD=brotli
override_dh_install:
	cp bin/bro bin/$(BROTLI_CMD)
	dh_install

override_dh_auto_clean:
	rm -f bin/$(BROTLI_CMD)
	dh_auto_clean

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	dh_auto_test
	debian/smoke_test.sh
	make test
endif

## brotli 0.8

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 0.8
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen.ooms@stat.ucla.edu", role = c("aut", "cre")),
    person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that uses a combination of the
    LZ77 algorithm and Huffman coding. Brotli is similar in speed to deflate (gzip)
    but offers more dense compression.
License: MIT + file LICENSE
URL: https://tools.ietf.org/html/rfc7932
        https://github.com/google/brotli#readme
BugReports: http://github.com/jeroenooms/brotli/issues
VignetteBuilder: knitr, R.rsp
Suggests: knitr, R.rsp, microbenchmark, rmarkdown, ggplot2
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-08-01 07:56:34 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [aut, cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen.ooms@stat.ucla.edu>
Repository: CRAN
Date/Publication: 2016-08-01 13:07:50

## brotli 1.0

=== DESCRIPTION ===
Package: brotli
Type: Package
Title: A Compression Format Optimized for the Web
Version: 1.0
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen@berkeley.edu", role = c("aut", "cre")),
    person("Google, Inc", role = c("aut","cph"), comment = "Brotli C++ library")
  )
Description: A lossless compressed data format that uses a combination of the
    LZ77 algorithm and Huffman coding. Brotli is similar in speed to deflate (gzip)
    but offers more dense compression.
License: MIT + file LICENSE
URL: https://tools.ietf.org/html/rfc7932
        https://github.com/google/brotli#readme
BugReports: http://github.com/jeroen/brotli/issues
VignetteBuilder: knitr, R.rsp
Suggests: knitr, R.rsp, microbenchmark, rmarkdown, ggplot2
RoxygenNote: 6.0.1
NeedsCompilation: yes
Packaged: 2017-03-18 18:36:36 UTC; jeroen
Author: Jeroen Ooms [aut, cre],
  Google, Inc [aut, cph] (Brotli C++ library)
Maintainer: Jeroen Ooms <jeroen@berkeley.edu>
Repository: CRAN
Date/Publication: 2017-03-18 22:10:36 UTC

## brotli 1.0.3

=== CMakeLists.txt ===
# Ubuntu 12.04 LTS has CMake 2.8.7, and is an important target since
# several CI services, such as Travis and Drone, use it.  Solaris 11
# has 2.8.6, and it's not difficult to support if you already have to
# support 2.8.7.
cmake_minimum_required(VERSION 2.8.6)

project(brotli)

# If Brotli is being bundled in another project, we don't want to
# install anything.  However, we want to let people override this, so
# we'll use the BROTLI_BUNDLED_MODE variable to let them do that; just
# set it to OFF in your project before you add_subdirectory(brotli).
get_directory_property(BROTLI_PARENT_DIRECTORY PARENT_DIRECTORY)
if(BROTLI_BUNDLED_MODE STREQUAL "")
  # Bundled mode hasn't been set one way or the other, set the default
  # depending on whether or not we are the top-level project.
  if(BROTLI_PARENT_DIRECTORY)
    set(BROTLI_BUNDLED_MODE OFF)
  else()
    set(BROTLI_BUNDLED_MODE ON)
  endif()
endif()
mark_as_advanced(BROTLI_BUNDLED_MODE)

include(GNUInstallDirs)

# Parse version information from common/version.h. Normally we would
# define these values here and write them out to configuration file(s)
# (i.e., config.h), but in this case we parse them from
# common/version.h to be less intrusive.
function(hex_to_dec HEXADECIMAL DECIMAL)
  string(TOUPPER "${HEXADECIMAL}" _tail)
  set(_decimal 0)
  string(LENGTH "${_tail}" _tail_length)
  while (_tail_length GREATER 0)
    math(EXPR _decimal "${_decimal} * 16")
    string(SUBSTRING "${_tail}" 0 1 _digit)
    string(SUBSTRING "${_tail}" 1 -1 _tail)
    if (_digit STREQUAL "A")
      math(EXPR _decimal "${_decimal} + 10")
    elseif (_digit STREQUAL "B")
      math(EXPR _decimal "${_decimal} + 11")
    elseif (_digit STREQUAL "C")
      math(EXPR _decimal "${_decimal} + 12")
    elseif (_digit STREQUAL "D")
      math(EXPR _decimal "${_decimal} + 13")
    elseif (_digit STREQUAL "E")
      math(EXPR _decimal "${_decimal} + 14")
    elseif (_digit STREQUAL "F")
      math(EXPR _decimal "${_decimal} + 15")
    else()
      math(EXPR _decimal "${_decimal} + ${_digit}")
    endif()
    string(LENGTH "${_tail}" _tail_length)
  endwhile()
  set(${DECIMAL} ${_decimal} PARENT_SCOPE)
endfunction(hex_to_dec)

# Version information
file(STRINGS "c/common/version.h" _brotli_version_line REGEX "^#define BROTLI_VERSION (0x[0-9a-fA-F]+)$")
string(REGEX REPLACE "^#define BROTLI_VERSION 0x([0-9a-fA-F]+)$" "\\1" _brotli_version_hex "${_brotli_version_line}")
hex_to_dec("${_brotli_version_hex}" _brotli_version)
math(EXPR BROTLI_VERSION_MAJOR "${_brotli_version} >> 24")
math(EXPR BROTLI_VERSION_MINOR "(${_brotli_version} >> 12) & 4095")
math(EXPR BROTLI_VERSION_PATCH "${_brotli_version} & 4095")
set(BROTLI_VERSION "${BROTLI_VERSION_MAJOR}.${BROTLI_VERSION_MINOR}.${BROTLI_VERSION_PATCH}")
mark_as_advanced(BROTLI_VERSION BROTLI_VERSION_MAJOR BROTLI_VERSION_MINOR BROTLI_VERSION_PATCH)

# ABI Version information
file(STRINGS "c/common/version.h" _brotli_abi_info_line REGEX "^#define BROTLI_ABI_VERSION (0x[0-9a-fA-F]+)$")
string(REGEX REPLACE "^#define BROTLI_ABI_VERSION 0x([0-9a-fA-F]+)$" "\\1" _brotli_abi_info_hex "${_brotli_abi_info_line}")
hex_to_dec("${_brotli_abi_info_hex}" _brotli_abi_info)
math(EXPR BROTLI_ABI_CURRENT "${_brotli_abi_info} >> 24")
math(EXPR BROTLI_ABI_REVISION "(${_brotli_abi_info} >> 12) & 4095")
math(EXPR BROTLI_ABI_AGE "${_brotli_abi_info} & 4095")
math(EXPR BROTLI_ABI_COMPATIBILITY "${BROTLI_ABI_CURRENT} - ${BROTLI_ABI_AGE}")
mark_as_advanced(BROTLI_ABI_CURRENT BROTLI_ABI_REVISION BROTLI_ABI_AGE BROTLI_ABI_COMPATIBILITY)

if (ENABLE_SANITIZER)
  set(CMAKE_C_FLAGS " ${CMAKE_C_FLAGS} -fsanitize=${ENABLE_SANITIZER}")
  set(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -fsanitize=${ENABLE_SANITIZER}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=${ENABLE_SANITIZER}")

  # By default, brotli depends on undefined behavior, but setting
  # BROTLI_BUILD_PORTABLE should result in a build which does not.
  if(ENABLE_SANITIZER STREQUAL "undefined")
    add_definitions(-DBROTLI_BUILD_PORTABLE)
  endif()
endif ()

include(CheckFunctionExists)
set(LIBM_LIBRARY)
CHECK_FUNCTION_EXISTS(log2 LOG2_RES)
if(NOT LOG2_RES)
  set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};m")
  CHECK_FUNCTION_EXISTS(log2 LOG2_LIBM_RES)
  if(LOG2_LIBM_RES)
    set(LIBM_LIBRARY "m")
  else()
    message(FATAL_ERROR "log2() not found")
  endif()

  set(CMAKE_REQUIRED_LIBRARIES "${orig_req_libs}")
  unset(LOG2_LIBM_RES)
  unset(orig_req_libs)
endif()
unset(LOG2_RES)

set(BROTLI_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/c/include")
mark_as_advanced(BROTLI_INCLUDE_DIRS)

set(BROTLI_LIBRARIES_CORE brotlienc brotlidec brotlicommon)
set(BROTLI_LIBRARIES ${BROTLI_LIBRARIES_CORE} ${LIBM_LIBRARY})
mark_as_advanced(BROTLI_LIBRARIES)

set(BROTLI_LIBRARIES_CORE_STATIC brotlienc-static brotlidec-static brotlicommon-static)
set(BROTLI_LIBRARIES_STATIC ${BROTLI_LIBRARIES_CORE_STATIC} ${LIBM_LIBRARY})
mark_as_advanced(BROTLI_LIBRARIES_STATIC)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  add_definitions(-DOS_LINUX)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  add_definitions(-DOS_FREEBSD)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  add_definitions(-DOS_MACOSX)
endif()

function(transform_sources_list INPUT_FILE OUTPUT_FILE)
  file(READ ${INPUT_FILE} TEXT)
  string(REGEX REPLACE "\\\\\n" "~continuation~" TEXT ${TEXT})
  string(REGEX REPLACE "([a-zA-Z_][a-zA-Z0-9_]*)[\t ]*=[\t ]*([^\n]*)" "SET(\\1 \\2)" TEXT ${TEXT})
  string(REPLACE "~continuation~" "\n" TEXT ${TEXT})
  file(WRITE ${OUTPUT_FILE} ${TEXT})
endfunction()

transform_sources_list("scripts/sources.lst" "${CMAKE_CURRENT_BINARY_DIR}/sources.lst.cmake")
include("${CMAKE_CURRENT_BINARY_DIR}/sources.lst.cmake")

add_library(brotlicommon SHARED ${BROTLI_COMMON_C})
add_library(brotlidec SHARED ${BROTLI_DEC_C})
add_library(brotlienc SHARED ${BROTLI_ENC_C})

add_library(brotlicommon-static STATIC ${BROTLI_COMMON_C})
add_library(brotlidec-static STATIC ${BROTLI_DEC_C})
add_library(brotlienc-static STATIC ${BROTLI_ENC_C})

# Older CMake versions does not understand INCLUDE_DIRECTORIES property.
include_directories(${BROTLI_INCLUDE_DIRS})

foreach(lib brotlicommon brotlidec brotlienc)
  target_compile_definitions(${lib} PUBLIC "BROTLI_SHARED_COMPILATION" )
  string(TOUPPER "${lib}" LIB)
  set_target_properties (${lib} PROPERTIES DEFINE_SYMBOL "${LIB}_SHARED_COMPILATION" )
endforeach()

foreach(lib brotlicommon brotlidec brotlienc brotlicommon-static brotlidec-static brotlienc-static)
  target_link_libraries(${lib} ${LIBM_LIBRARY})
  set_property(TARGET ${lib} APPEND PROPERTY INCLUDE_DIRECTORIES ${BROTLI_INCLUDE_DIRS})
  set_target_properties(${lib} PROPERTIES
    VERSION "${BROTLI_ABI_COMPATIBILITY}.${BROTLI_ABI_AGE}.${BROTLI_ABI_REVISION}"
    SOVERSION "${BROTLI_ABI_COMPATIBILITY}"
    POSITION_INDEPENDENT_CODE TRUE)
  set_property(TARGET ${lib} APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${BROTLI_INCLUDE_DIRS}")
endforeach()

target_link_libraries(brotlidec brotlicommon)
target_link_libraries(brotlienc brotlicommon)

target_link_libraries(brotlidec-static brotlicommon-static)
target_link_libraries(brotlienc-static brotlicommon-static)

# For projects stuck on older versions of CMake, this will set the
# BROTLI_INCLUDE_DIRS and BROTLI_LIBRARIES variables so they still
# have a relatively easy way to use Brotli:
#
#   include_directories(${BROTLI_INCLUDE_DIRS})
#   target_link_libraries(foo ${BROTLI_LIBRARIES})
if(BROTLI_PARENT_DIRECTORY)
  set(BROTLI_INCLUDE_DIRS "${BROTLI_INCLUDE_DIRS}" PARENT_SCOPE)
  set(BROTLI_LIBRARIES "${BROTLI_LIBRARIES}" PARENT_SCOPE)
endif()

# Build the brotli executable
add_executable(brotli ${BROTLI_CLI_C})
target_link_libraries(brotli ${BROTLI_LIBRARIES_STATIC})

# Installation
if(NOT BROTLI_BUNDLED_MODE)
  install(
    TARGETS brotli
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )

  install(
    TARGETS ${BROTLI_LIBRARIES_CORE}
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )

  install(
    TARGETS ${BROTLI_LIBRARIES_CORE_STATIC}
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )

  install(
    DIRECTORY ${BROTLI_INCLUDE_DIRS}/brotli
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  )
endif()

# Tests

# If we're targeting Windows but not running on Windows, we need Wine
# to run the tests...
if(NOT BROTLI_DISABLE_TESTS)
  if(WIN32 AND NOT CMAKE_HOST_WIN32)
    find_program(BROTLI_WINE NAMES wine)

    if(NOT BROTLI_WINE)
      message(STATUS "wine not found, disabling tests")
      set(BROTLI_DISABLE_TESTS TRUE)
    endif()
  endif()
endif()

if(NOT BROTLI_DISABLE_TESTS)
  include(CTest)
  enable_testing()

  set(ROUNDTRIP_INPUTS
    tests/testdata/alice29.txt
    tests/testdata/asyoulik.txt
    tests/testdata/lcet10.txt
    tests/testdata/plrabn12.txt
    c/enc/encode.c
    c/common/dictionary.h
    c/dec/decode.c)

  foreach(INPUT ${ROUNDTRIP_INPUTS})
    get_filename_component(OUTPUT_NAME "${INPUT}" NAME)

    set(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${OUTPUT_NAME}")
    set(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")

    foreach(quality 1 6 9 11)
      add_test(NAME "${BROTLI_TEST_PREFIX}roundtrip/${INPUT}/${quality}"
        COMMAND "${CMAKE_COMMAND}"
          -DBROTLI_WRAPPER=${BROTLI_WINE}
          -DBROTLI_CLI=$<TARGET_FILE:brotli>
          -DQUALITY=${quality}
          -DINPUT=${INPUT_FILE}
          -DOUTPUT=${OUTPUT_FILE}.${quality}
          -P ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-roundtrip-test.cmake)
    endforeach()
  endforeach()

  file(GLOB_RECURSE
    COMPATIBILITY_INPUTS
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    tests/testdata/*.compressed*)

  foreach(INPUT ${COMPATIBILITY_INPUTS})
    add_test(NAME "${BROTLI_TEST_PREFIX}compatibility/${INPUT}"
      COMMAND "${CMAKE_COMMAND}"
        -DBROTLI_WRAPPER=${BROTLI_WINE}
        -DBROTLI_CLI=$<TARGET_FILE:brotli>
        -DINPUT=${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}
        -P ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-compatibility-test.cmake)
  endforeach()
endif()

# Generate a pkg-config files

function(generate_pkg_config_path outvar path)
  string(LENGTH "${path}" path_length)

  set(path_args ${ARGV})
  list(REMOVE_AT path_args 0 1)
  list(LENGTH path_args path_args_remaining)

  set("${outvar}" "${path}")

  while(path_args_remaining GREATER 1)
    list(GET path_args 0 name)
    list(GET path_args 1 value)

    get_filename_component(value_full "${value}" ABSOLUTE)
    string(LENGTH "${value}" value_length)

    if(path_length EQUAL value_length AND path STREQUAL value)
      set("${outvar}" "\${${name}}")
      break()
    elseif(path_length GREATER value_length)
      # We might be in a subdirectory of the value, but we have to be
      # careful about a prefix matching but not being a subdirectory
      # (for example, /usr/lib64 is not a subdirectory of /usr/lib).
      # We'll do this by making sure the next character is a directory
      # separator.
      string(SUBSTRING "${path}" ${value_length} 1 sep)
      if(sep STREQUAL "/")
        string(SUBSTRING "${path}" 0 ${value_length} s)
        if(s STREQUAL value)
          string(SUBSTRING "${path}" "${value_length}" -1 suffix)
          set("${outvar}" "\${${name}}${suffix}")
          break()
        endif()
      endif()
    endif()

    list(REMOVE_AT path_args 0 1)
    list(LENGTH path_args path_args_remaining)
  endwhile()

  set("${outvar}" "${${outvar}}" PARENT_SCOPE)
endfunction(generate_pkg_config_path)

function(transform_pc_file INPUT_FILE OUTPUT_FILE VERSION)
  file(READ ${INPUT_FILE} TEXT)

  set(PREFIX "${CMAKE_INSTALL_PREFIX}")
  string(REGEX REPLACE "@prefix@" "${PREFIX}" TEXT ${TEXT})
  string(REGEX REPLACE "@exec_prefix@" "${PREFIX}" TEXT ${TEXT})

  generate_pkg_config_path(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}" prefix "${PREFIX}")

=== debian/changelog ===
brotli (1.0.3-1ubuntu1) bionic; urgency=medium

  * Apply pull requests #651, #656 to fix alignment issues on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Apr 2018 14:42:31 +0200

brotli (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Drop obsolete patches

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 06 Mar 2018 00:00:39 +0100

brotli (1.0.2-3) unstable; urgency=medium

  [ Jeremy Bicha ]
  * Use dh_missing --fail-missing (Closes: #888950)

  [ Tomasz Buchert ]
  * d/copyright: remove appveyor path (Closes: #888947)
  * Bump debhelper compat to 11

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 31 Jan 2018 23:52:35 +0100

brotli (1.0.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 07 Dec 2017 09:51:13 +0100

brotli (1.0.2-1~exp0) experimental; urgency=medium

  * New upstream version 1.0.2
  * Updated std-ver to 4.1.0 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 03 Dec 2017 11:57:59 +0100

brotli (1.0.0-1~exp0) experimental; urgency=medium

  * New upstream version 1.0.0
  * d/*: migrate 0.6.0 to 1.0.0
  * d/symbols: fix symbols file (Closes: #870831)
  * d/patches: refresh
  * Upload to experimental

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 22 Sep 2017 00:18:40 +0200

brotli (0.6.0-2~exp0) experimental; urgency=medium

  [Tomasz Buchert]
  * d/gbp.conf: remove obsolete gbp.conf
  * d/control: add Ondřej to Uploaders
  * debian: provide shared libs pkgs
  * d/control: bump Standards-Version to 4 (no changes needed)

  [Ondřej Surý]
  * Use SOVERSION in libbrotli package name and add symbols file
  * Rewrite smoke_test.sh as autopkgtests
  * Upload to experimental
  * Add missing cmake to Build-Depends
  * Fix libbrotli0.6.0.symbols to refer to correct package
  * Add lintian override for amalgated libbrotli0.6.0 package

 -- Ondřej Surý <ondrej@debian.org>  Wed, 28 Jun 2017 14:23:39 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,9 @@
 Section: python
 Priority: optional
 Maintainer: Tomasz Buchert <tomasz@debian.org>
-Build-Depends: debhelper (>= 10),
+Uploaders: Ondřej Surý <ondrej@debian.org>
+Build-Depends: cmake,
+               debhelper (>= 11),
                dh-python,
                python,
                python-dev,
@@ -10,10 +12,10 @@
                python3,
                python3-dev,
                python3-setuptools
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: https://github.com/google/brotli
-Vcs-Git: git://anonscm.debian.org/collab-maint/brotli.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/brotli.git
+Vcs-Git: https://salsa.debian.org/debian/brotli.git
+Vcs-Browser: https://salsa.debian.org/debian/brotli
 
 Package: python-brotli
 Architecture: any
@@ -54,3 +56,33 @@
  deflate but offers more dense compression.
  .
  This package installs a command line utility.
+
+Package: libbrotli-dev
+Section: libdevel
+Architecture: any
+Depends: libbrotli1 (= ${binary:Version}), ${misc:Depends}
+Description: library implementing brotli encoder and decoder (development files)
+ Brotli is a generic-purpose lossless compression algorithm
+ that compresses data using a combination of a modern variant
+ of the LZ77 algorithm, Huffman coding and 2nd order context modeling,
+ with a compression ratio comparable to the best currently available
+ general-purpose compression methods. It is similar in speed with
+ deflate but offers more dense compression.
+ .
+ This package installs development files.
+
+Package: libbrotli1
+Section: libs
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: library implementing brotli encoder and decoder (shared libraries)
+ Brotli is a generic-purpose lossless compression algorithm
+ that compresses data using a combination of a modern variant
+ of the LZ77 algorithm, Huffman coding and 2nd order context modeling,
+ with a compression ratio comparable to the best currently available
+ general-purpose compression methods. It is similar in speed with
+ deflate but offers more dense compression.
+ .
+ This package installs shared libraries.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg//,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/brotli-$1\.tar\.gz/ \
  https://github.com/google/brotli/tags .*/v?(\d\S*)\.tar\.gz

## brotli 1.0.5

=== debian/changelog ===
brotli (1.0.5-2~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 14 Nov 2018 13:55:12 -0800

brotli (1.0.5-2~bpo9+1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 15 Oct 2018 14:22:21 -0700

brotli (1.0.5-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Aron Xu <aron@debian.org>  Sat, 04 Aug 2018 17:41:29 +0000

brotli (1.0.5-2) unstable; urgency=medium

  * depend on python3-all-dev (Closes: #903923)

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 02 Aug 2018 15:35:52 +0800

brotli (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 01 Jul 2018 22:36:19 +0200

brotli (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 28 Apr 2018 16:01:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: brotli
 Section: python
 Priority: optional
-Maintainer: Tomasz Buchert <tomasz@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 11),
+               debhelper (>= 10),
                dh-python,
                python,
                python-dev,
                python-setuptools,
                python3,
-               python3-dev,
+               python3-all-dev,
                python3-setuptools
 Standards-Version: 4.1.1
 Homepage: https://github.com/google/brotli

## brotli 1.0.6

=== debian/changelog ===
brotli (1.0.6-1) unstable; urgency=medium

  * New upstream version 1.0.6

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 22 Sep 2018 10:16:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: brotli
+Maintainer: Tomasz Buchert <tomasz@debian.org>
+Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: python
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
-Uploaders: Ondřej Surý <ondrej@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 11),
                dh-python,
                python,
                python-dev,
@@ -13,10 +12,10 @@
                python3,
                python3-all-dev,
                python3-setuptools
-Standards-Version: 4.1.1
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/debian/brotli
+Vcs-Git: https://salsa.debian.org/debian/brotli.git
 Homepage: https://github.com/google/brotli
-Vcs-Git: https://salsa.debian.org/debian/brotli.git
-Vcs-Browser: https://salsa.debian.org/debian/brotli
 
 Package: python-brotli
 Architecture: any
@@ -59,8 +58,8 @@
  This package installs a command line utility.
 
 Package: libbrotli-dev
+Architecture: any
 Section: libdevel
-Architecture: any
 Depends: libbrotli1 (= ${binary:Version}), ${misc:Depends}
 Description: library implementing brotli encoder and decoder (development files)
  Brotli is a generic-purpose lossless compression algorithm
@@ -73,11 +72,11 @@
  This package installs development files.
 
 Package: libbrotli1
-Section: libs
 Architecture: any
 Multi-Arch: same
+Section: libs
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: library implementing brotli encoder and decoder (shared libraries)
  Brotli is a generic-purpose lossless compression algorithm
  that compresses data using a combination of a modern variant

## brotli 1.0.7

=== debian/changelog ===
brotli (1.0.7-2~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.
  * Revert to debhelper 10 compat.
  * debian/rules: 
    - change dh_missing override to dh_install for debhelper 10.
    - disable automatic dbgsym packages.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 24 Mar 2019 13:15:33 -0700

brotli (1.0.7-2) unstable; urgency=medium

  * Refresh packaging (std-ver, compat=12)

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 07 Jan 2019 23:11:10 +0100

brotli (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 27 Oct 2018 13:08:16 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Section: python
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 11),
+               debhelper (>= 10),
+#               debhelper-compat (= 12),
                dh-python,
                python,
                python-dev,
@@ -12,7 +13,7 @@
                python3,
                python3-all-dev,
                python3-setuptools
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian/brotli
 Vcs-Git: https://salsa.debian.org/debian/brotli.git
 Homepage: https://github.com/google/brotli

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export PYBUILD_NAME = brotli

%:
	dh $@ --buildsystem=pybuild --with=python2,python3

override_dh_auto_configure:
	dh_auto_configure
	dh_auto_configure --buildsystem=cmake

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=cmake

override_dh_auto_test:
	dh_auto_test
	dh_auto_test --buildsystem=cmake

override_dh_install:
	find debian/tmp -name '*.a' -print -delete
	dh_install

override_dh_install:
	dh_install --list-missing

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## brotli 1.0.7.1

=== debian/changelog ===
brotli (1.0.7.1-1+eagle) unstable; urgency=medium

  * update

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 17 Dec 2020 14:32:35 +0800

brotli (1.0.7-2+deb10u1) buster-security; urgency=medium

  * CVE-2020-8927

 -- Moritz Mühlenhoff <jmm@debian.org>  Wed, 25 Nov 2020 22:33:28 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Section: python
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
-#               debhelper-compat (= 12),
+               debhelper (>= 12),
+               debhelper-compat (= 12),
                dh-python,
                python,
                python-dev,
